---
# This file is licensed under the MIT License (MIT) available on
# http://opensource.org/licenses/MIT.

layout: base
lang: en
id: developer-documentation
title: "Developer Documentation - Bitcoin"
---

# Developer Documentation

<p class="summary">Find useful resources, guides and reference material for developers.</p>

<div class="docreference">
<a href="/en/developer-guide"><img src="/img/icons/main_ico_compass.svg" alt="icon"><span>Developer Guide</span><span>(How Bitcoin works)</span></a>
<a href="/en/developer-reference"><img src="/img/icons/main_ico_guide.svg" alt="icon"><span>Developer Reference</span><span>(Specifications and APIs)</span></a>
<a href="/en/developer-examples"><img src="/img/icons/main_ico_hash.svg" alt="icon"><span>Developer Examples</span><span>(Examples you can use)</span></a>
</div>

<div class="resources">
  <div><div>
      <h2><img src="/img/icons/ico_blockchain.svg" class="titleicon" alt="Icon">Block Chain</h2>
      <p><a href="/en/developer-guide#block-chain">Block Chain Guide</a></p>
      <p><a href="/en/developer-reference#block-chain">Block Chain Reference</a></p>
    </div><div>
      <h2><img src="/img/icons/ico_micro.svg" class="titleicon" alt="Icon">Transactions</h2>
      <p><a href="/en/developer-guide#transactions">Transactions Guide</a></p>
      <p><a href="/en/developer-reference#transactions">Transactions Reference</a></p>
      <p><a href="/en/developer-examples#transactions">Transaction Examples</a></p>
    </div>
  </div>
  <div>
    <div>
      <h2><img src="/img/icons/ico_contract.svg" class="titleicon" alt="Icon">Contracts</h2>
      <p><a href="/en/developer-guide#contracts">Contracts Guide</a></p>
      <div class="resourcesext">
        <p><a href="https://en.bitcoin.it/wiki/Contracts">More Contracts</a> - Wiki</p>
        <p><a href="https://bitcoinj.github.io/working-with-micropayments">Micropayment Channel Example</a> - bitcoinj</p>
      </div>
    </div><div>
      <h2><img src="/img/icons/ico_key.svg" class="titleicon" alt="Icon">Wallets</h2>
      <p><a href="/en/developer-guide#wallets">Wallets Guide</a></p>
      <p><a href="/en/developer-reference#wallets">Wallets Reference</a></p>
      <div class="resourcesext">
        <p><a href="https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki">HD Wallets</a> - BIP32</p>
        <p><a href="https://github.com/bitcoin/bips/blob/master/bip-0039.mediawiki">Mnemonic Code</a> - BIP39</p>
      </div>
    </div>
  </div>
  <div>
    <div>
      <h2><img src="/img/icons/ico_bill.svg" class="titleicon" alt="Icon">Payment Processing</h2>
      <p><a href="/en/developer-guide#payment-processing">Payment Processing Guide</a></p>
      <p><a href="/en/developer-examples#payment-processing">Payment Processing Examples</a></p>
      <div class="resourcesext">
        <p><a href="https://github.com/bitcoin/bips/blob/master/bip-0070.mediawiki">Payment Protocol</a> - BIP70</p>
      </div>
    </div><div>
      <h2><img src="/img/icons/ico_conf.svg" class="titleicon" alt="Icon">Operating Modes</h2>
      <p><a href="/en/developer-guide#operating-modes">Operating Modes Guide</a></p>
    </div>
  </div>
  <div>
    <div>
      <h2><img src="/img/icons/ico_network.svg" class="titleicon" alt="Icon">P2P Network</h2>
      <p><a href="/en/developer-guide#p2p-network">P2P Network Guide</a></p>
      <p><a href="/en/developer-reference#p2p-network">P2P Network Reference</a></p>
      <p><a href="/en/developer-examples#p2p-network">P2P Network Examples</a></p>
      <div class="resourcesext">
        <p><a href="https://en.bitcoin.it/wiki/Protocol_specification">Full Protocol Specification</a> - Wiki</p>
      </div>
    </div><div>
      <h2><img src="/img/icons/ico_mining.svg" class="titleicon" alt="Icon">Mining</h2>
      <p><a href="/en/developer-guide#mining">Mining Guide</a></p>
      <div class="resourcesext">
        <p><a href="https://github.com/bitcoin/bips/blob/master/bip-0022.mediawiki">getworktemplate Fundamentals</a> - BIP22</p>
        <p><a href="https://github.com/bitcoin/bips/blob/master/bip-0023.mediawiki">getworktemplate Pooled Mining</a> - BIP23</p>
      </div>
    </div>
  </div>
</div>

<div class="resourcesmore"><div>
  <h2><img src="/img/icons/ico_wiki.svg" class="titleicon" alt="Icon">Additional resources</h2>
  <p><a href="/bitcoin.pdf">Bitcoin: A Peer-to-Peer Electronic Cash System</a> - Satoshi Nakamoto</p>
  <p><a href="https://github.com/bitcoin/bips#readme">Bitcoin Improvement Proposals</a> - GitHub</p>
  <p><a href="https://github.com/minium/Bitcoin-Spec">Bitcoin Developer Reference (working paper)</a> - Krzysztof Okupski</p>
  <p><a href="https://bitcoinj.github.io/#documentation">Bitcoinj Developer Documentation</a> - bitcoinj.org</p>
  <p><a href="https://en.bitcoin.it/wiki/Category:Technical">Technical Pages</a> - Wiki</p>
</div></div>
